Package org.optaplanner.core.api.score.buildin.hardmediumsoft

## Interface HardMediumSoftScoreHolder

- All Superinterfaces:
    `ScoreHolder<HardMediumSoftScore>`
  All Known Implementing Classes:
    `HardMediumSoftScoreHolderImpl`

      public interface HardMediumSoftScoreHolder
      extends ScoreHolder<HardMediumSoftScore>

  See Also:
    `HardMediumSoftScore`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeight)` |
    `void` | `addMediumConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int mediumWeight)` |
    `void` | `addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeight, int mediumWeight, int softWeight)` |
    `void` | `addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int softWeight)` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` |
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeightMultiplier, int mediumWeightMultiplier, int softWeightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeightMultiplier, int mediumWeightMultiplier, int softWeightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level.

    - ### Methods inherited from interface org.optaplanner.core.api.score.holder.ScoreHolder

      `penalize, reward`

- - ### Method Detail

    - #### penalize

          void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                        int weightMultiplier)

      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### penalize

          void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                        int hardWeightMultiplier,
                        int mediumWeightMultiplier,
                        int softWeightMultiplier)

      Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level. Slower than `penalize(RuleContext, int)`.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `mediumWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### reward

          void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                      int weightMultiplier)

      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                      int hardWeightMultiplier,
                      int mediumWeightMultiplier,
                      int softWeightMultiplier)

      Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level. Slower than `reward(RuleContext, int)`.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `mediumWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### impactScore

          void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                           int weightMultiplier)

    - #### addHardConstraintMatch

          void addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                      int hardWeight)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - higher is better, negative for a penalty, positive for a reward

    - #### addMediumConstraintMatch

          void addMediumConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                        int mediumWeight)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `mediumWeight` - higher is better, negative for a penalty, positive for a reward

    - #### addSoftConstraintMatch

          void addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                      int softWeight)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `softWeight` - higher is better, negative for a penalty, positive for a reward

    - #### addMultiConstraintMatch

          void addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                       int hardWeight,
                                       int mediumWeight,
                                       int softWeight)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - higher is better, negative for a penalty, positive for a reward
        `mediumWeight` - higher is better, negative for a penalty, positive for a reward
        `softWeight` - higher is better, negative for a penalty, positive for a reward